// We will place the definitions for only
// Rational's operations in this file

#include "Rational.hpp"

//Rational::Rational()
//{
//	mNumerator = 0;
//	mDenominator = 1;
//}
//
//Rational::Rational(int newNumerator, int newDenominator)
//{
//	mNumerator = newNumerator;
//	mDenominator = newDenominator;
//}

Rational::Rational(const int newNumerator, const int newDenominator)
{
	mNumerator = newNumerator;

	// validate the denominator
	if (newDenominator != 0)
	{
		mDenominator = newDenominator;
	}
	else
	{
		mDenominator = 1;
	}
}

// copy assignment operator
Rational& Rational::operator= (const Rational& rhs)
{
	if (this != &rhs) // check for self-assignment - if both operands are the same object - 
		              // then no need to make a copy of the data members.
	{
		mNumerator = rhs.getNumerator();
		mDenominator = rhs.getDenominator();
		cout << "operator= address of value in the \"this\" pointer: " << this << endl;
	}

	return *this; // return a reference to the instance of the implied object on the left hand
	              // side of the assignment operator
}

int Rational::getNumerator() const
{
	return mNumerator;
}

int Rational::getDenominator() const
{
	return mDenominator;
}

void Rational::setNumerator(const int newNumerator)
{
	mNumerator = newNumerator;
}

void Rational::setDenominator(const int newDenominator)
{
	// validate the denominator
	if (newDenominator != 0)
	{
		mDenominator = newDenominator;
	}
}

// implicitly called when passing-by-value
Rational::Rational(const Rational& copy)
{
	//mNumerator = copy.mNumerator; // could also work
	setNumerator(copy.getNumerator());
	setDenominator(copy.getDenominator());

	// let's rewrite using the copy assignment operator!
}

Rational Rational::add(const Rational& rhs)
{
	Rational result;

	result.setDenominator(rhs.getDenominator() *
		getDenominator());
	result.setNumerator(rhs.getNumerator() * getDenominator() +
		getNumerator() * rhs.getDenominator());

	return result;
}

Rational::~Rational()
{
	cout << "Inside destructor for Rational" << std::endl;
}



ifstream& operator>> (ifstream& lhs, Rational& rhs)
{
	int num = 0;
	lhs >> num;
	rhs.setNumerator(num);
	char slash = '\0';
	lhs >> slash;
	lhs >> num;
	rhs.setDenominator(num);

	return lhs;
}